//---------------------------------------------------------------------------
#ifndef postmainH
#define postmainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <vcl\inifiles.hpp>
#include <Buttons.hpp>
#include "rtklib.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TOpenDialog *OpenDialog;
	TPanel *Panel1;
	TSaveDialog *SaveDialog;
	TPanel *Panel2;
	TPanel *Message;
	TProgressBar *Progress;
	TButton *BtnPlot;
	TButton *BtnView;
	TButton *BtnToKML;
	TButton *BtnOption;
	TButton *BtnExec;
	TButton *BtnExit;
	TPanel *Panel3;
	TCheckBox *TimeStart;
	TEdit *TimeY1;
	TEdit *TimeH1;
	TCheckBox *TimeEnd;
	TUpDown *TimeH1UD;
	TEdit *TimeY2;
	TUpDown *TimeY2UD;
	TEdit *TimeH2;
	TUpDown *TimeH2UD;
	TCheckBox *TimeIntF;
	TCheckBox *TimeUnitF;
	TEdit *TimeUnit;
	TLabel *LabelTimeInt;
	TLabel *LabelTimeUnit;
	TUpDown *TimeY1UD;
	TPanel *Panel4;
	TLabel *LabelInputFile1;
	TSpeedButton *BtnInputPlot1;
	TSpeedButton *BtnInputView1;
	TSpeedButton *BtnInputView2;
	TLabel *LabelInputFile2;
	TSpeedButton *BtnInputView3;
	TSpeedButton *BtnInputPlot3;
	TLabel *LabelInputFile3;
	TComboBox *InputFile1;
	TButton *BtnInputFile1;
	TButton *BtnInputFile2;
	TComboBox *InputFile2;
	TButton *BtnInputFile3;
	TComboBox *InputFile3;
	TPanel *Panel5;
	TComboBox *OutputFile;
	TButton *BtnOutputFile;
	TLabel *Label1;
	TSpeedButton *BtnTime1;
	TSpeedButton *BtnTime2;
	TSpeedButton *BtnAbout;
	TComboBox *TimeInt;
	TComboBox *InputFile4;
	TButton *BtnInputFile4;
	TSpeedButton *BtnInputView4;
	TSpeedButton *BtnOutputView1;
	TSpeedButton *BtnOutputView2;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall PosModeChange(TObject *Sender);
	void __fastcall BtnInputFile1Click(TObject *Sender);
	void __fastcall BtnInputFile2Click(TObject *Sender);
	void __fastcall BtnInputFile3Click(TObject *Sender);
	void __fastcall BtnOutputFileClick(TObject *Sender);
	void __fastcall SolFormatChange(TObject *Sender);
	void __fastcall BtnExecClick(TObject *Sender);
	void __fastcall BtnToKMLClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnViewClick(TObject *Sender);
	void __fastcall BtnStopClick(TObject *Sender);
	void __fastcall SolutionChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall RefPosClick(TObject *Sender);
	void __fastcall BtnPlotClick(TObject *Sender);
	void __fastcall BtnOptionClick(TObject *Sender);
	void __fastcall BtnInputView1Click(TObject *Sender);
	void __fastcall BtnInputView2Click(TObject *Sender);
	void __fastcall BtnInputView3Click(TObject *Sender);
	void __fastcall TimeStartClick(TObject *Sender);
	void __fastcall TimeIntFClick(TObject *Sender);
	void __fastcall BtnInputPlot1Click(TObject *Sender);
	void __fastcall BtnInputPlot3Click(TObject *Sender);
	void __fastcall TimeH1UDChangingEx(TObject *Sender, bool &AllowChange,
          short NewValue, TUpDownDirection Direction);
	void __fastcall TimeY1UDChangingEx(TObject *Sender, bool &AllowChange,
          short NewValue, TUpDownDirection Direction);
	void __fastcall TimeY2UDChangingEx(TObject *Sender, bool &AllowChange,
          short NewValue, TUpDownDirection Direction);
	void __fastcall TimeH2UDChangingEx(TObject *Sender, bool &AllowChange,
          short NewValue, TUpDownDirection Direction);
	void __fastcall TimeUnitFClick(TObject *Sender);
	void __fastcall BtnTime1Click(TObject *Sender);
	void __fastcall BtnTime2Click(TObject *Sender);
	void __fastcall BtnAboutClick(TObject *Sender);
	void __fastcall BtnInputView4Click(TObject *Sender);
	void __fastcall BtnInputFile4Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall InputFile1Change(TObject *Sender);
	void __fastcall BtnOutputView1Click(TObject *Sender);
	void __fastcall BtnOutputView2Click(TObject *Sender);
private:
	int __fastcall ExecProc(void);
	int __fastcall ExecProc1(gtime_t ts, gtime_t te);
	int __fastcall ExecProc2(gtime_t ts, gtime_t te, AnsiString rov);
	int __fastcall ExecProcUnit(gtime_t ts, gtime_t te, AnsiString rov,
		AnsiString base);
	void __fastcall UpdateEnable(void);
	int __fastcall GetOption(prcopt_t &prcopt, solopt_t &solopt,
		AnsiString input1, AnsiString input3);
	int __fastcall ObsToNav(const char *obsfile, char *navfile);
	int __fastcall ObsToGnav(const char *obsfile, char *gnavfile);
	int __fastcall GetPos(char *file, double *rr);
	void __fastcall AddHist(TComboBox *combo);
	TStringList * __fastcall ReadList(TIniFile *ini, AnsiString cat,
		AnsiString key);
	void __fastcall WriteList(TIniFile *ini, AnsiString cat,
		AnsiString key, TStrings *list);
	int __fastcall ExecCmd(AnsiString cmd, int show);
	AnsiString __fastcall FilePath(AnsiString file);
	AnsiString __fastcall RepFile(AnsiString file, gtime_t time, AnsiString rov,
		AnsiString base);
	AnsiString __fastcall RepStr(AnsiString str, AnsiString pat, AnsiString rep);
	gtime_t _fastcall GetTime1(void);
	gtime_t _fastcall GetTime2(void);
	void _fastcall SetTime1(gtime_t time);
	void _fastcall SetTime2(gtime_t time);
	void __fastcall DropFiles(TWMDropFiles msg); // for files drop
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_DROPFILES,TWMDropFiles,DropFiles);
	END_MESSAGE_MAP(TForm);
public:
	int PosMode,Freq,Solution,DynamicModel,IonoEst,TropEst,RcvBiasEst;
	int NumIter,CodeSmooth;
	int OutCntResetBias,LockCntFixAmb,RovPosType,RefPosType,SatEphem,NavSys;
	int RovAntPcv,RefAntPcv,AmbRes,GloAmbRes,OutputHead,OutputOpt,OutputDatum;
	int OutputHeight,OutputGeoid,DebugTrace,DebugStatus,BaseLineConst;
	int SolFormat,TimeFormat,LatLonFormat,IntpRefObs,NetRSCorr,SatClkCorr;
	int SbasCorr,SbasCorr1,SbasCorr2,SbasCorr3,SbasCorr4,TimeDecimal;
	double ElMask,SnrMask,MaxAgeDiff,RejectThres;
	double MeasErr1,MeasErr2,MeasErr3,MeasErr4,MeasErr5;
	double SatClkStab,RovAntE,RovAntN,RovAntU,RefAntE,RefAntN,RefAntU;
	double PrNoise1,PrNoise2,PrNoise3,PrNoise4,PrNoise5;
	double ValidThresAR,ElMaskAR,SlipThres;
	double RovPos[3],RefPos[3],BaseLine[2];
	AnsiString FieldSep,RovAnt,RefAnt,AntPcvFile,StaPosFile,PrecEphFile;
	AnsiString NetRSCorrFile1,NetRSCorrFile2,SatClkCorrFile,GoogleEarthFile;
	AnsiString GeoidDataFile;
	AnsiString SbasCorrFile,SatPcvFile,ExSats;
	AnsiString RovList,BaseList;
	void __fastcall ViewFile(AnsiString file);
	void __fastcall ShowMsg(char *msg);
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
