/*------------------------------------------------------------------------------
* rtklib unit test driver : atomospheric model functions
*-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <assert.h>
#include "../../src/rtklib.h"

/* ionmodel() */
void utest1(void)
{
	printf("%s utest1 : OK\n",__FILE__);
}
/* ionmapf() */
void utest2(void)
{
	printf("%s utest2 : OK\n",__FILE__);
}
/* tropmodel */
void utest3(void)
{
	printf("%s utest3 : OK\n",__FILE__);
}
/* tropmapf */
static void printmapf(gtime_t t, double *pos, double *azel, double mapfd, double mapfw)
{
	char s[64];
	time2str(t,s,0); s[10]='\0';
	printf("%s : pos=%5.1f %6.1f %4.0f azel=%6.1f %5.1f : mapf=%7.4f %7.4f\n",
	       s,pos[0]*R2D,pos[1]*R2D,pos[2],azel[0]*R2D,azel[1]*R2D,mapfd,mapfw);
}
void utest4(void)
{
	double mapfd,mapfw;
	double e1[]={2007,1,10,6,0,0},e2[]={2030,12,31,23,59,59};
	double pos1[]={ 35*D2R, 140*D2R, 100.0};
	double pos2[]={-80*D2R,-170*D2R,1000.0};
	double pos3[]={ 10*D2R,  30*D2R,   0.0};
	double azel1[]={ 60*D2R, 75*D2R};
	double azel2[]={190*D2R,  3*D2R};
	double azel3[]={350*D2R, 60*D2R};
	double azel4[]={  0*D2R, 90*D2R};
	gtime_t t1=epoch2time(e1),t2=epoch2time(e2);

	mapfd=tropmapf(t1,pos1,azel1,&mapfw);
	printmapf(t1,pos1,azel1,mapfd,mapfw);
	mapfd=tropmapf(t1,pos1,azel2,&mapfw);
	printmapf(t1,pos1,azel2,mapfd,mapfw);
	mapfd=tropmapf(t1,pos1,azel3,&mapfw);
	printmapf(t1,pos1,azel3,mapfd,mapfw);
	mapfd=tropmapf(t1,pos1,azel4,&mapfw);
	printmapf(t1,pos1,azel4,mapfd,mapfw);
	mapfd=tropmapf(t2,pos1,azel1,&mapfw);
	printmapf(t2,pos1,azel1,mapfd,mapfw);
	mapfd=tropmapf(t1,pos2,azel1,&mapfw);
	printmapf(t1,pos2,azel1,mapfd,mapfw);
	mapfd=tropmapf(t1,pos3,azel1,&mapfw);
	printmapf(t1,pos3,azel1,mapfd,mapfw);
	printf("%s utset4 : OK\n",__FILE__);
}
int main(void)
{
	utest1();
	utest2();
	utest3();
	utest4();
	return 0;
}
